#include <stdio.h>
#include <math.h>

#define  PI  3.141592653589

void precess2000(float ra_1, float dec_1, float eq_1, float *ra_0, float *dec_0);

int main()

{
    float  ra_1=0.0, dec_1=0.0;
    float  ra_0, dec_0;
    float  val;

    ra_1 = 5.589605;
    dec_1 = -5.368805;
    precess2000(ra_1, dec_1, 2002.95, &ra_0, &dec_0);
    printf("%f %f\n", ra_0, dec_0);
}


/*******************/

void precess2000(float ra_1, float dec_1, float eq_1, float *ra_0, float *dec_0)

/* From Astronomical Almanac, p. B19 */

{
    float  T, M, N, am, dm;
    float  a, d;

    T = (eq_1 - 2000.0)/100.0;
    M = 1.2812323*T + 0.0003879*T*T + 0.0000101*T*T*T;
    M *= (PI/180.0);
    N = 0.5567530*T - 0.0001185*T*T + 0.0000116*T*T*T;
    N *= (PI/180.0);

    a = ra_1*15.0*PI/180.0;
    d = dec_1*PI/180.0;
    am = a - 0.5*(M + N*sin(a)*tan(d));
    dm = d - 0.5*N*cos(am);

    *ra_0 = -1.0*M - N*sin(am)*tan(dm);
    *ra_0 *= (180.0/PI/15.0);
    *ra_0 += ra_1;
    *dec_0 = -1.0*N*cos(am);
    *dec_0 *= (180.0/PI);
    *dec_0 += dec_1;
}

